require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_HV_COMPAT_H)) {
    eval 'sub _HV_COMPAT_H () {1;}' unless defined(&_HV_COMPAT_H);
    eval 'sub CN_KVP_IDX () {0x9;}' unless defined(&CN_KVP_IDX);
    eval 'sub CN_KVP_VAL () {0x1;}' unless defined(&CN_KVP_VAL);
    if(defined(&__KERNEL__)) {
	require 'linux/rcupdate.ph';
	require 'linux/version.ph';
	require 'linux/netdevice.ph';
	require 'linux/input.ph';
	require 'linux/inetdevice.ph';
	require 'linux/libata-compat.ph';
	require 'asm/byteorder.ph';
	require 'asm/unaligned.ph';
	require 'net/arp.ph';
	require 'scsi/scsi.ph';
	require 'scsi/scsi_cmnd.ph';
	require 'scsi/scsi_dbg.ph';
	require 'scsi/scsi_device.ph';
	require 'scsi/scsi_driver.ph';
	require 'scsi/scsi_eh.ph';
	require 'scsi/scsi_host.ph';
	eval 'sub CN_KVP_IDX () {0x9;}' unless defined(&CN_KVP_IDX);
	eval 'sub CN_KVP_VAL () {0x1;}' unless defined(&CN_KVP_VAL);
	eval 'sub IRQ0_VECTOR () { &FIRST_EXTERNAL_VECTOR;}' unless defined(&IRQ0_VECTOR);
	eval 'sub page {
	    eval q(* &skb_frag_page( &const  &skb_frag_t * &frag) {  ($frag->{page}); });
	}' unless defined(&page);
	eval 'sub void {
	    eval q(* &sg_virt(\'struct scatterlist\' * &sg) {  ($sg->{page}); });
	}' unless defined(&void);
	eval 'sub hv_set_buf {
	    my($sg,$buf,$length) = @_;
    	    eval q({  ($sg->{page}) = $buf;  ($sg->{length}) = $length; });
	}' unless defined(&hv_set_buf);
	eval 'sub dev_set_name {
	    my($dev,$fmt,$num) = @_;
    	    eval q({ \'int\'  &err;  &sprintf( ($dev->{bus_id}), $fmt, $num);  &err =  &kobject_set_name( ($dev->{kobj}), $fmt, $num);  &err; });
	}' unless defined(&dev_set_name);
	eval 'sub __DELAYED_WORK_INITIALIZER {
	    my($n, $f, $d) = @_;
    	    eval q({ . ($work->{e$ntry})  = { ( ($n->{work})). &entry, ( ($n->{work})). &entry }, . ($work->{func}) = ($f), . ($work->{data}) = ($d), . ($work->{timer}) =  &TIMER_INITIALIZER( &NULL, 0, 0), });
	}' unless defined(&__DELAYED_WORK_INITIALIZER);
	eval 'sub DECLARE_DELAYED_WORK {
	    my($n, $f, $d) = @_;
    	    eval q(\'struct delayed_work\' $n =  &__DELAYED_WORK_INITIALIZER($n, $f, $d));
	}' unless defined(&DECLARE_DELAYED_WORK);
	eval 'sub orderly_poweroff {
	    my($x) = @_;
    	    eval q( &rhel_5_x_power_off());
	}' unless defined(&orderly_poweroff);
	eval 'sub BUS_VIRTUAL () {0x6;}' unless defined(&BUS_VIRTUAL);
	eval 'sub HID_ANY_ID () {(~0);}' unless defined(&HID_ANY_ID);
	eval 'sub HID_BUS_ANY () {0xffff;}' unless defined(&HID_BUS_ANY);
	eval 'sub BTN_TRIGGER_HAPPY () {0x2c0;}' unless defined(&BTN_TRIGGER_HAPPY);
	eval 'sub KEY_CONTEXT_MENU () {0x1b6;}' unless defined(&KEY_CONTEXT_MENU);
	eval 'sub KEY_VIDEOPHONE () {0x1a0;}' unless defined(&KEY_VIDEOPHONE);
	eval 'sub KEY_GAMES () {0x1a1;}' unless defined(&KEY_GAMES);
	eval 'sub KEY_MEDIA_REPEAT () {0x1b7;}' unless defined(&KEY_MEDIA_REPEAT);
	eval 'sub KEY_WORDPROCESSOR () {0x1a5;}' unless defined(&KEY_WORDPROCESSOR);
	eval 'sub KEY_EDITOR () {0x1a6;}' unless defined(&KEY_EDITOR);
	eval 'sub KEY_SPREADSHEET () {0x1a7;}' unless defined(&KEY_SPREADSHEET);
	eval 'sub KEY_GRAPHICSEDITOR () {0x1a8;}' unless defined(&KEY_GRAPHICSEDITOR);
	eval 'sub KEY_PRESENTATION () {0x1a9;}' unless defined(&KEY_PRESENTATION);
	eval 'sub KEY_DATABASE () {0x1aa;}' unless defined(&KEY_DATABASE);
	eval 'sub KEY_NEWS () {0x1ab;}' unless defined(&KEY_NEWS);
	eval 'sub KEY_VOICEMAIL () {0x1ac;}' unless defined(&KEY_VOICEMAIL);
	eval 'sub KEY_ADDRESSBOOK () {0x1ad;}' unless defined(&KEY_ADDRESSBOOK);
	eval 'sub KEY_LOGOFF () {0x1b1;}' unless defined(&KEY_LOGOFF);
	eval 'sub KEY_SPELLCHECK () {0x1b0;}' unless defined(&KEY_SPELLCHECK);
	eval 'sub KEY_IMAGES () {0x1ba;}' unless defined(&KEY_IMAGES);
	eval 'sub KEY_MESSENGER () {0x1ae;}' unless defined(&KEY_MESSENGER);
	eval 'sub KEY_ZOOMIN () {0x1a2;}' unless defined(&KEY_ZOOMIN);
	eval 'sub KEY_ZOOMOUT () {0x1a3;}' unless defined(&KEY_ZOOMOUT);
	eval 'sub KEY_ZOOMRESET () {0x1a4;}' unless defined(&KEY_ZOOMRESET);
	eval 'sub ABS_MT_POSITION_X () {0x35;}' unless defined(&ABS_MT_POSITION_X);
	eval 'sub INPUT_KEYMAP_BY_INDEX () {(1<< 0);}' unless defined(&INPUT_KEYMAP_BY_INDEX);
	undef(&CONFIG_HIDRAW) if defined(&CONFIG_HIDRAW);
	eval 'sub void {
	    eval q(* &input_get_drvdata(\'struct input_dev\' * &dev) {  ($dev->{dev}); });
	}' unless defined(&void);
	eval 'sub input_set_drvdata {
	    my($dev,$data) = @_;
    	    eval q({  ($dev->{dev}) = $data; });
	}' unless defined(&input_set_drvdata);
	eval 'sub input_scancode_to_scalar {
	    my($ke,$scancode) = @_;
    	    eval q({  &switch ( ($ke->{len})) {  &case 1: *$scancode = *(( &u8 *) ($ke->{scancode}));  &break;  &case 2: *$scancode = *(( &u16 *) ($ke->{scancode}));  &break;  &case 4: *$scancode = *(( &u32 *) ($ke->{scancode}));  &break;  &default: - &EINVAL; } 0; });
	}' unless defined(&input_scancode_to_scalar);
	eval 'sub SYN_REPORT () {0;}' unless defined(&SYN_REPORT);
	eval 'sub SYN_CONFIG () {1;}' unless defined(&SYN_CONFIG);
	eval 'sub SYN_MT_REPORT () {2;}' unless defined(&SYN_MT_REPORT);
	eval 'sub SYN_DROPPED () {3;}' unless defined(&SYN_DROPPED);
	eval 'sub ABS_MT_TOUCH_MAJOR () {0x30;}' unless defined(&ABS_MT_TOUCH_MAJOR);
	eval 'sub ABS_MT_DISTANCE () {0x3b;}' unless defined(&ABS_MT_DISTANCE);
	eval 'sub ABS_MT_TOUCH_MINOR () {0x31;}' unless defined(&ABS_MT_TOUCH_MINOR);
	eval 'sub ABS_MT_WIDTH_MAJOR () {0x32;}' unless defined(&ABS_MT_WIDTH_MAJOR);
	eval 'sub ABS_MT_WIDTH_MINOR () {0x33;}' unless defined(&ABS_MT_WIDTH_MINOR);
	eval 'sub ABS_MT_ORIENTATION () {0x34;}' unless defined(&ABS_MT_ORIENTATION);
	eval 'sub ABS_MT_POSITION_Y () {0x36;}' unless defined(&ABS_MT_POSITION_Y);
	eval 'sub ABS_MT_TOOL_TYPE () {0x37;}' unless defined(&ABS_MT_TOOL_TYPE);
	eval 'sub ABS_MT_BLOB_ID () {0x38;}' unless defined(&ABS_MT_BLOB_ID);
	eval 'sub ABS_MT_FIRST () { &ABS_MT_TOUCH_MAJOR;}' unless defined(&ABS_MT_FIRST);
	eval 'sub ABS_MT_LAST () { &ABS_MT_DISTANCE;}' unless defined(&ABS_MT_LAST);
	eval 'sub ABS_MAX () {0x3f;}' unless defined(&ABS_MAX);
	eval 'sub ABS_CNT () {( &ABS_MAX+1);}' unless defined(&ABS_CNT);
	eval 'sub get_unaligned_le16 {
	    my($p) = @_;
    	    eval q({  &le16_to_cpu( &get_unaligned(( &__le16 *)$p)); });
	}' unless defined(&get_unaligned_le16);
	eval 'sub get_unaligned_le32 {
	    my($p) = @_;
    	    eval q({  &le32_to_cpu( &get_unaligned(( &__le32 *)$p)); });
	}' unless defined(&get_unaligned_le32);
	eval 'sub get_unaligned_le64 {
	    my($p) = @_;
    	    eval q({  &le64_to_cpu( &get_unaligned(( &__le64 *)$p)); });
	}' unless defined(&get_unaligned_le64);
	eval 'sub put_unaligned_le64 {
	    my($val,$p) = @_;
    	    eval q({  &put_unaligned( &cpu_to_be64($val), ( &__le64 *)$p); });
	}' unless defined(&put_unaligned_le64);
    }
}
1;
